# 03_LLM_Assignments

## Prompt 
Du bist ein Experte für Softwareentwicklung und Git. Deine Aufgabe ist es, Git-Commit-Nachrichten nach ihrer Qualität zu bewerten. Orientiere dich an den Best Practices von Chris Beams:
1. Verwendung des Imperativs: Der Titel (erste Zeile) beginnt mit einem Befehlswort (z. B. „Fix“, „Add“, „Update“). Kein „Fixed“ oder „Added“.
2. Länge des Titels: Der Titel ist maximal 50 Zeichen lang.
3. Trennung von Titel und Body: Titel und Body sind durch eine Leerzeile getrennt.
4. Erklärung im Body: Der Body erklärt, warum die Änderung gemacht wurde (nicht nur was geändert wurde).
5. Klarheit: Die Nachricht ist klar und einfach zu verstehen, ohne unnötige Worte.
6. Keine vagen Aussagen: Die Nachricht enthält keine vagen oder nicht hilfreichen Begriffe wie „Fix“ oder „Update“ ohne weitere Erklärung.
7. Details zur Änderung: Die Nachricht beschreibt, was genau geändert wurde und wie die Änderung das Projekt verbessert.

Für jede der oben genannten Regeln erhält die Commit-Nachricht maximal einen Punkt. Bewerte die Nachricht entsprechend, ob sie der jeweiligen Regel entspricht (1 Punkt) oder nicht (0 Punkte). Das maximale Bewertungsergebnis sind 7 Punkte.

## Bewertung von 5 Git Commit Messages (Excel-Tabelle "Good")
| Commit Message  | Score by ChatGPT  | Score by Copilot  |
|-----------------|-------------------|-------------------|
| Fix crash on login due to null user token  |  4  |  4  |
| Rework the @PropertySource parsing logic recently changed in commit 7c608886 to deal with the same source appearing on a @Configuration class and an @Import class  |  4  |  4  |
| Issue: SPR-12059  |  1  |  1  |
| Update HierarchicalUriComponents.toUri() to only prepend a missing '/' when the scheme, user info, host or port are specified. This makes the toUri() method behave in the same way as .toUriString() and allows relative URIs to be created.  |  5  |  4  |
| UriComponentsBuilder supports query without value  |  1  |  1  |

## Bewertung von 5 Git Commit Messages (Excel-Tabelle "Bad")
| Commit Message  | Score by ChatGPT  | Score by Copilot  |
|-----------------|-------------------|-------------------|
| refactoring .testsuite .aop.aspectj tests in preparation for migration to .context  |  3  |  3  |
| re-adding mock.jndi.* artifacts to .orm test codebase eliminated after moving away from svn:externals  |  4  |  4  |
| IN PROGRESS - issue SPR-5599: Hook @Configuration class processing into <context:component-scan/> and <context:annotation-config/> through AnnotationConfigUtils#registerAnnotationConfigProcessors  |  3  |  3  |
|  + Adding POC tooling integration points, namely AbstractConfigurationPostProcessor and allowing for tooling-specified ClassLoader for use with ASM parsing + Eliminated ModelMethod in favor of BeanMethod throughout  |  6  |  4  |
| polishing  |  2  |  2  |